/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* MLIR TFLite Runtime Verifiers                                              *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

::mlir::LogicalResult AbsOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<AbsOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(16))) || ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 16-bit signless integer or 32-bit float or QI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(16))) || ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 16-bit signless integer or 32-bit float or QI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult AddNOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<AddNOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult AddOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<AddOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifyAddOpShapeConstraints(llvm::cast<AddOp>(top))))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that Operands do not have valid shapes");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ArgMaxOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ArgMaxOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 8-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ArgMinOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ArgMinOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 8-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult AssignVariableOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<AssignVariableOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isa<mlir::TF::ResourceType>())) || ((elementType.isa<mlir::TF::ResourceRefType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of resource values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isF64())) || ((elementType.isSignlessInteger(1))) || ((elementType.isUnsignedInteger(8))) || ((elementType.isSignlessInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || (((elementType.isa<::mlir::ComplexType>())) && ((elementType.cast<::mlir::ComplexType>().getElementType().isF32()))) || (((elementType.isa<::mlir::ComplexType>())) && ((elementType.cast<::mlir::ComplexType>().getElementType().isF64()))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 64-bit float or 1-bit signless integer or 8-bit unsigned integer or 8-bit signless integer or QI8 type or QUI8 type or 32-bit signless integer or 64-bit signless integer or QI16 type or complex type with 32-bit float elements or complex type with 64-bit float elements values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult AveragePool2DOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<AveragePool2DOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult BasicLSTMOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<BasicLSTMOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(3)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 32))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI32 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(4)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSResults(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QUI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSResults(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSResults(3)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QUI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult BatchMatMulOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<BatchMatMulOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QI16 type or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QI16 type or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isSignlessInteger(32))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QI8 type or QI16 type or 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult BatchToSpaceNdOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<BatchToSpaceNdOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 32-bit signless integer or 64-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult BidirectionalSequenceLSTMOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<BidirectionalSequenceLSTMOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(3)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(4)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(5)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(6)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(7)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(8)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(9)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(10)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(11)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(12)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(13)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(14)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(15)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(16)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(17)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(18)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(19)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(20)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(21)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(22)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(23)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(24)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(25)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(26)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(27)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(28)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(29)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(30)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(31)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(32)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(33)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(34)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(39)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(40)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(41)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(42)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(43)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(44)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(45)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(46)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(47)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult BroadcastArgsOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<BroadcastArgsOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult BroadcastToOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<BroadcastToOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isSignlessInteger(16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<::mlir::ComplexType>())) && ((elementType.cast<::mlir::ComplexType>().getElementType().isF32()))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 1-bit signless integer or 8-bit signless integer or QI8 type or 8-bit unsigned integer or QUI8 type or 16-bit signless integer or QI16 type or 64-bit signless integer or complex type with 32-bit float elements values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isSignlessInteger(16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<::mlir::ComplexType>())) && ((elementType.cast<::mlir::ComplexType>().getElementType().isF32()))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 1-bit signless integer or 8-bit signless integer or QI8 type or 8-bit unsigned integer or QUI8 type or 16-bit signless integer or QI16 type or 64-bit signless integer or complex type with 32-bit float elements values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult BucketizeOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<BucketizeOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isF64())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 64-bit float or 32-bit signless integer or 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult CallOnceOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<CallOnceOp>(op); (void)top;
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult CastOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<CastOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isUnsignedInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isa<mlir::TF::Quint8Type>())) || ((elementType.isUnsignedInteger(8))) || ((elementType.isSignlessInteger(8))) || (((elementType.isa<::mlir::ComplexType>())) && ((elementType.cast<::mlir::ComplexType>().getElementType().isF32()))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 1-bit signless integer or 16-bit signless integer or 32-bit signless integer or 32-bit unsigned integer or 64-bit signless integer or TFLite quint8 type or 8-bit unsigned integer or 8-bit signless integer or complex type with 32-bit float elements values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isUnsignedInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isa<mlir::TF::Quint8Type>())) || ((elementType.isUnsignedInteger(8))) || ((elementType.isSignlessInteger(8))) || (((elementType.isa<::mlir::ComplexType>())) && ((elementType.cast<::mlir::ComplexType>().getElementType().isF32()))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 1-bit signless integer or 16-bit signless integer or 32-bit signless integer or 32-bit unsigned integer or 64-bit signless integer or TFLite quint8 type or 8-bit unsigned integer or 8-bit signless integer or complex type with 32-bit float elements values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult CeilOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<CeilOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ComplexAbsOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ComplexAbsOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (((elementType.isa<::mlir::ComplexType>())) && ((elementType.cast<::mlir::ComplexType>().getElementType().isF32()))) || (((elementType.isa<::mlir::ComplexType>())) && ((elementType.cast<::mlir::ComplexType>().getElementType().isF64()))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of complex type with 32-bit float elements or complex type with 64-bit float elements values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isF64())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 64-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ConcatenationOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ConcatenationOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isUnsignedInteger(8))) || ((elementType.isSignlessInteger(1))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 64-bit signless integer or 32-bit signless integer or 16-bit signless integer or 8-bit signless integer or QI8 type or QUI8 type or 8-bit unsigned integer or 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isUnsignedInteger(8))) || ((elementType.isSignlessInteger(1))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 64-bit signless integer or 32-bit signless integer or 16-bit signless integer or 8-bit signless integer or QI8 type or QUI8 type or 8-bit unsigned integer or 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ConstOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ConstOp>(op); (void)top;
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult Conv2DOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<Conv2DOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult Conv3DOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<Conv3DOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult Conv3DTransposeOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<Conv3DTransposeOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(3)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult CosOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<CosOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult CumsumOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<CumsumOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult CustomOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<CustomOp>(op); (void)top;
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult CustomTfOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<CustomTfOp>(op); (void)top;
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult DensifyOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<DensifyOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult DepthToSpaceOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<DepthToSpaceOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isa<mlir::TF::Quint8Type>())) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 32-bit signless integer or 64-bit signless integer or TFLite quint8 type or 8-bit unsigned integer or QI8 type or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isa<mlir::TF::Quint8Type>())) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 32-bit signless integer or 64-bit signless integer or TFLite quint8 type or 8-bit unsigned integer or QI8 type or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult DepthwiseConv2DOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<DepthwiseConv2DOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) && (((v.getType().cast<::mlir::ShapedType>().hasRank())) && ((v.getType().cast<::mlir::ShapedType>().getRank()
                         == 1)))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be 1D tensor of any type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult DequantizeOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<DequantizeOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isF16())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of QI8 type or QUI8 type or QI16 type or 16-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult DivOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<DivOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifyOperandsHaveSameShapesOrBroadcastableShape(top, llvm::ArrayRef<unsigned>({0, 1}), 5)))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that operands do not have the same shape or broadcastable shapes within the rank 5");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult EluOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<EluOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult EmbeddingLookupOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<EmbeddingLookupOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 8-bit unsigned integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 8-bit unsigned integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult EqualOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<EqualOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(1))) || ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isUnsignedInteger(8))) || ((elementType.isa<mlir::TF::StringType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 1-bit signless integer or 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or 8-bit unsigned integer or TFLite string type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(1))) || ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isUnsignedInteger(8))) || ((elementType.isa<mlir::TF::StringType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 1-bit signless integer or 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or 8-bit unsigned integer or TFLite string type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifyOperandsHaveSameShapesOrBroadcastableShape(top, llvm::ArrayRef<unsigned>({0, 1}), 4)))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that operands do not have the same shape or broadcastable shapes within the rank 4");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ExpOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ExpOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ExpandDimsOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ExpandDimsOp>(op); (void)top;
  {
    unsigned index = 1;
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ExternalConstOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ExternalConstOp>(op); (void)top;
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult FakeQuantOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<FakeQuantOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult FillOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<FillOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(1))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::StringType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or 1-bit signless integer or QI8 type or QI16 type or TFLite string type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(1))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::StringType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or 1-bit signless integer or QI8 type or QI16 type or TFLite string type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult FloorDivOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<FloorDivOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifyOperandsHaveSameShapesOrBroadcastableShape(top, llvm::ArrayRef<unsigned>({0, 1}), 4)))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that operands do not have the same shape or broadcastable shapes within the rank 4");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult FloorModOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<FloorModOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isF32())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer or 64-bit signless integer or 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isF32())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer or 64-bit signless integer or 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isF32())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit signless integer or 64-bit signless integer or 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifyOperandsHaveSameShapesOrBroadcastableShape(top, llvm::ArrayRef<unsigned>({0, 1}), 4)))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that operands do not have the same shape or broadcastable shapes within the rank 4");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult FloorOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<FloorOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult FullyConnectedOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<FullyConnectedOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or QI16 type or QUI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI32 type or QUI32 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or QI16 type or QUI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult GatherNdOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<GatherNdOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(32))) || ((elementType.isUnsignedInteger(8))) || ((elementType.isa<mlir::TF::StringType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 16-bit signless integer or 64-bit signless integer or 32-bit signless integer or 8-bit unsigned integer or TFLite string type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(32))) || ((elementType.isUnsignedInteger(8))) || ((elementType.isa<mlir::TF::StringType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 16-bit signless integer or 64-bit signless integer or 32-bit signless integer or 8-bit unsigned integer or TFLite string type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult GatherOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<GatherOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isa<mlir::TF::StringType>())) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 1-bit signless integer or 8-bit signless integer or 32-bit signless integer or 64-bit signless integer or TFLite string type or 8-bit unsigned integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer or 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isa<mlir::TF::StringType>())) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 1-bit signless integer or 8-bit signless integer or 32-bit signless integer or 64-bit signless integer or TFLite string type or 8-bit unsigned integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult GreaterEqualOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<GreaterEqualOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QUI8 type or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QUI8 type or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifyOperandsHaveSameShapesOrBroadcastableShape(top, llvm::ArrayRef<unsigned>({0, 1}), 4)))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that operands do not have the same shape or broadcastable shapes within the rank 4");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult GreaterOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<GreaterOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QUI8 type or QI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QUI8 type or QI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifyOperandsHaveSameShapesOrBroadcastableShape(top, llvm::ArrayRef<unsigned>({0, 1}), 4)))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that operands do not have the same shape or broadcastable shapes within the rank 4");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult HardSwishOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<HardSwishOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QUI8 type or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QUI8 type or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult HashtableFindOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<HashtableFindOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isa<mlir::TF::ResourceType>())) || ((elementType.isa<mlir::TF::ResourceRefType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of resource values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isa<mlir::TF::StringType>())) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer or TFLite string type or 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isa<mlir::TF::StringType>())) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or TFLite string type or 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isa<mlir::TF::StringType>())) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or TFLite string type or 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult HashtableImportOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<HashtableImportOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isa<mlir::TF::ResourceType>())) || ((elementType.isa<mlir::TF::ResourceRefType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of resource values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isa<mlir::TF::StringType>())) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer or TFLite string type or 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isa<mlir::TF::StringType>())) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or TFLite string type or 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult HashtableOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<HashtableOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isa<mlir::TF::ResourceType>())) || ((elementType.isa<mlir::TF::ResourceRefType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of resource values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult HashtableSizeOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<HashtableSizeOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isa<mlir::TF::ResourceType>())) || ((elementType.isa<mlir::TF::ResourceRefType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of resource values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(64)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult IfOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<IfOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ImagOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ImagOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (((elementType.isa<::mlir::ComplexType>())) && ((elementType.cast<::mlir::ComplexType>().getElementType().isF32()))) || (((elementType.isa<::mlir::ComplexType>())) && ((elementType.cast<::mlir::ComplexType>().getElementType().isF64()))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of complex type with 32-bit float elements or complex type with 64-bit float elements values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isF64())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 64-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult L2NormalizationOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<L2NormalizationOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QUI8 type or QI8 type or QUI16 type or QI16 type or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isSignlessInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QUI8 type or QI8 type or QUI16 type or QI16 type or 8-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult LSTMOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<LSTMOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(3)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(4)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(5)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(6)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(7)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(8)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(9)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QI16 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(10)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QI16 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(11)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QI16 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(12)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI32 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(13)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 32))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI32 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(14)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 32))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI32 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(15)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 32))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI32 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(16)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(17)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI32 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(20)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI16 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(21)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI16 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(22)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI16 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(23)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI16 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult LeakyReluOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<LeakyReluOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QUI8 type or QI8 type or TFLite quint8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QUI8 type or QI8 type or TFLite quint8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult LessEqualOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<LessEqualOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifyOperandsHaveSameShapesOrBroadcastableShape(top, llvm::ArrayRef<unsigned>({0, 1}), 4)))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that operands do not have the same shape or broadcastable shapes within the rank 4");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult LessOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<LessOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QUI8 type or QI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QUI8 type or QI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifyOperandsHaveSameShapesOrBroadcastableShape(top, llvm::ArrayRef<unsigned>({0, 1}), 4)))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that operands do not have the same shape or broadcastable shapes within the rank 4");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult LocalResponseNormalizationOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<LocalResponseNormalizationOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult LogOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<LogOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult LogSoftmaxOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<LogSoftmaxOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QUI8 type or QI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QUI8 type or QI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult LogicalAndOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<LogicalAndOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult LogicalNotOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<LogicalNotOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult LogicalOrOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<LogicalOrOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult LogisticOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<LogisticOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or QI16 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or QI16 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult MatrixDiagOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<MatrixDiagOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or 8-bit unsigned integer or QUI8 type or QI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or 8-bit unsigned integer or QUI8 type or QI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult MatrixSetDiagOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<MatrixSetDiagOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or 8-bit unsigned integer or QI8 type or QI16 type or QUI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or 8-bit unsigned integer or QI8 type or QI16 type or QUI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or 8-bit unsigned integer or QI8 type or QI16 type or QUI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult MaxPool2DOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<MaxPool2DOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QUI8 type or QI8 type or QI16 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QUI8 type or QI8 type or QI16 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult MaximumOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<MaximumOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64)))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32/64-bit signless integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64)))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32/64-bit signless integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64)))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32/64-bit signless integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifyOperandsHaveSameShapesOrBroadcastableShape(top, llvm::ArrayRef<unsigned>({0, 1}), 5)))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that operands do not have the same shape or broadcastable shapes within the rank 5");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult MeanOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<MeanOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or 8-bit unsigned integer or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer or 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or 8-bit unsigned integer or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult MinimumOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<MinimumOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64)))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32/64-bit signless integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64)))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32/64-bit signless integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64)))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32/64-bit signless integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifyOperandsHaveSameShapesOrBroadcastableShape(top, llvm::ArrayRef<unsigned>({0, 1}), 5)))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that operands do not have the same shape or broadcastable shapes within the rank 5");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult MirrorPadOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<MirrorPadOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or 8-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer or 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or 8-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult MulOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<MulOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifyMulOpShapeConstraints(llvm::cast<MulOp>(top))))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that Operands do not have valid shapes");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult MultinomialOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<MultinomialOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit signless integer or 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult NegOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<NegOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult NonMaxSuppressionV4Op::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<NonMaxSuppressionV4Op>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(3)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(4)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSResults(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult NonMaxSuppressionV5Op::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<NonMaxSuppressionV5Op>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(3)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(4)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(5)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSResults(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSResults(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult NotEqualOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<NotEqualOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(1))) || ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || ((elementType.isa<mlir::TF::StringType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 1-bit signless integer or 32-bit float or 32-bit signless integer or 64-bit signless integer or QUI8 type or QI8 type or TFLite quint8 type or TFLite string type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(1))) || ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || ((elementType.isa<mlir::TF::StringType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 1-bit signless integer or 32-bit float or 32-bit signless integer or 64-bit signless integer or QUI8 type or QI8 type or TFLite quint8 type or TFLite string type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifyOperandsHaveSameShapesOrBroadcastableShape(top, llvm::ArrayRef<unsigned>({0, 1}), 4)))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that operands do not have the same shape or broadcastable shapes within the rank 4");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult NumericVerifyOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<NumericVerifyOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isF16())) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of QI8 type or QUI8 type or QI16 type or 16-bit float or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult OneHotOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<OneHotOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer or 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or 1-bit signless integer or 8-bit signless integer or 8-bit unsigned integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(3)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or 1-bit signless integer or 8-bit signless integer or 8-bit unsigned integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or 1-bit signless integer or 8-bit signless integer or 8-bit unsigned integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult PReluOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<PReluOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifyOperandsHaveSameShapesOrBroadcastableShape(top, llvm::ArrayRef<unsigned>({0, 1}), 4)))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that operands do not have the same shape or broadcastable shapes within the rank 4");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult PackOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<PackOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type or QI16 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type or QI16 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult PadOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<PadOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or TFLite quint8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or TFLite quint8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult PadV2Op::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<PadV2Op>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult PowOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<PowOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifyOperandsHaveSameShapesOrBroadcastableShape(top, llvm::ArrayRef<unsigned>({0, 1}), 4)))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that operands do not have the same shape or broadcastable shapes within the rank 4");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult QuantizeOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<QuantizeOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or QI16 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of QI8 type or QUI8 type or QI16 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult RFFT2dOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<RFFT2dOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isa<::mlir::ComplexType>())) && ((elementType.cast<::mlir::ComplexType>().getElementType().isF32())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of complex type with 32-bit float elements values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult RandomStandardNormalOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<RandomStandardNormalOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult RandomUniformOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<RandomUniformOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult RangeOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<RangeOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isF32())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer or 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isF32())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer or 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isF32())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer or 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isF32())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit signless integer or 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult RankOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<RankOp>(op); (void)top;
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ReadVariableOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ReadVariableOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isa<mlir::TF::ResourceType>())) || ((elementType.isa<mlir::TF::ResourceRefType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of resource values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isF64())) || ((elementType.isSignlessInteger(1))) || ((elementType.isUnsignedInteger(8))) || ((elementType.isSignlessInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || (((elementType.isa<::mlir::ComplexType>())) && ((elementType.cast<::mlir::ComplexType>().getElementType().isF32()))) || (((elementType.isa<::mlir::ComplexType>())) && ((elementType.cast<::mlir::ComplexType>().getElementType().isF64()))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 64-bit float or 1-bit signless integer or 8-bit unsigned integer or 8-bit signless integer or QI8 type or QUI8 type or 32-bit signless integer or 64-bit signless integer or QI16 type or complex type with 32-bit float elements or complex type with 64-bit float elements values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult RealOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<RealOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (((elementType.isa<::mlir::ComplexType>())) && ((elementType.cast<::mlir::ComplexType>().getElementType().isF32()))) || (((elementType.isa<::mlir::ComplexType>())) && ((elementType.cast<::mlir::ComplexType>().getElementType().isF64()))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of complex type with 32-bit float elements or complex type with 64-bit float elements values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isF64())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 64-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ReduceAllOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ReduceAllOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ReduceAnyOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ReduceAnyOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ReduceMaxOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ReduceMaxOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or TFLite quint8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or TFLite quint8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ReduceMinOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ReduceMinOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or TFLite quint8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or TFLite quint8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ReduceProdOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ReduceProdOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or TFLite quint8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or TFLite quint8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult Relu1Op::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<Relu1Op>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QUI8 type or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QUI8 type or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult Relu6Op::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<Relu6Op>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QUI8 type or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QUI8 type or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ReluOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ReluOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QUI8 type or QI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QUI8 type or QI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ReshapeOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ReshapeOp>(op); (void)top;
  {
    unsigned index = 1;
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ResizeBilinearOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ResizeBilinearOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or TFLite quint8 type or QUI8 type or QI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or TFLite quint8 type or QUI8 type or QI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ResizeNearestNeighborOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ResizeNearestNeighborOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or TFLite quint8 type or QUI8 type or QI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or TFLite quint8 type or QUI8 type or QI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ReverseSequenceOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ReverseSequenceOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI16 type or QUI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI16 type or QUI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ReverseV2Op::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ReverseV2Op>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isUnsignedInteger(8))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || ((elementType.isSignlessInteger(1))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit unsigned integer or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or QI16 type or QUI8 type or QI8 type or TFLite quint8 type or 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isUnsignedInteger(8))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || ((elementType.isSignlessInteger(1))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 8-bit unsigned integer or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or QI16 type or QUI8 type or QI8 type or TFLite quint8 type or 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult RoundOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<RoundOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult RsqrtOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<RsqrtOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SVDFOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SVDFOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(3)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI32 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ScatterNdOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ScatterNdOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(32))) || ((elementType.isUnsignedInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 64-bit signless integer or 32-bit signless integer or 8-bit unsigned integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(32))) || ((elementType.isUnsignedInteger(8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 64-bit signless integer or 32-bit signless integer or 8-bit unsigned integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SegmentSumOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SegmentSumOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SelectOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SelectOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 1-bit signless integer or 8-bit signless integer or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or QI16 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 1-bit signless integer or 8-bit signless integer or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or QI16 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 1-bit signless integer or 8-bit signless integer or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or QI16 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SelectV2Op::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SelectV2Op>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(1)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 1-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 1-bit signless integer or 8-bit signless integer or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or QI16 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 1-bit signless integer or 8-bit signless integer or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or QI16 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 1-bit signless integer or 8-bit signless integer or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or QI16 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifyOperandsHaveSameShapesOrBroadcastableShape(top, llvm::ArrayRef<unsigned>({0, 1, 2}), 4)))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that operands do not have the same shape or broadcastable shapes within the rank 4");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ShapeOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ShapeOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit signless integer or 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SinOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SinOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SliceOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SliceOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))) || ((elementType.isSignlessInteger(1))) || ((elementType.isa<mlir::TF::StringType>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or 8-bit signless integer or 8-bit unsigned integer or 1-bit signless integer or TFLite string type or QI8 type or QUI8 type or TFLite quint8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))) || ((elementType.isSignlessInteger(1))) || ((elementType.isa<mlir::TF::StringType>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or 8-bit signless integer or 8-bit unsigned integer or 1-bit signless integer or TFLite string type or QI8 type or QUI8 type or TFLite quint8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SoftmaxOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SoftmaxOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or TFLite quint8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or TFLite quint8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SpaceToBatchNdOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SpaceToBatchNdOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SpaceToDepthOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SpaceToDepthOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SparseConstOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SparseConstOp>(op); (void)top;
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SparseQConstOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SparseQConstOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of QUI8 type or QI8 type or QI16 type or QUI16 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SparseToDenseOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SparseToDenseOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || ((elementType.isF32())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer or 64-bit signless integer or 8-bit signless integer or QI8 type or 8-bit unsigned integer or QUI8 type or TFLite quint8 type or 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(3)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || ((elementType.isF32())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer or 64-bit signless integer or 8-bit signless integer or QI8 type or 8-bit unsigned integer or QUI8 type or TFLite quint8 type or 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || ((elementType.isF32())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit signless integer or 64-bit signless integer or 8-bit signless integer or QI8 type or 8-bit unsigned integer or QUI8 type or TFLite quint8 type or 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SplitOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SplitOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 16-bit signless integer or 32-bit signless integer or 8-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 16-bit signless integer or 32-bit signless integer or 8-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SplitVOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SplitVOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or 8-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 16-bit signless integer or 32-bit signless integer or 64-bit signless integer or 8-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SqrtOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SqrtOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SquareOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SquareOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SquaredDifferenceOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SquaredDifferenceOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifyOperandsHaveSameShapesOrBroadcastableShape(top, llvm::ArrayRef<unsigned>({0, 1}), 4)))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that operands do not have the same shape or broadcastable shapes within the rank 4");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SqueezeOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SqueezeOp>(op); (void)top;
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult StridedSliceOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<StridedSliceOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())) || ((elementType.isa<mlir::TF::StringType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or 8-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type or 1-bit signless integer or 16-bit signless integer or QI16 type or TFLite quint8 type or TFLite string type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(3)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())) || ((elementType.isa<mlir::TF::StringType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or 8-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type or 1-bit signless integer or 16-bit signless integer or QI16 type or TFLite quint8 type or TFLite string type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SubOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SubOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  if (!((TFL::VerifySubOpShapeConstraints(llvm::cast<SubOp>(top))))) {
        if (emit_error_on_verify_fail) {
      return top.emitOpError("failed to verify that Operands do not have valid shapes");
    } else {
      return failure();
  }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult SumOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<SumOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or TFLite quint8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 32-bit signless integer or 64-bit signless integer or QI8 type or QUI8 type or TFLite quint8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult TanhOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<TanhOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or QI16 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isa<mlir::TF::Quint8Type>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or QI16 type or TFLite quint8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult TileOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<TileOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::StringType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 1-bit signless integer or 32-bit signless integer or 64-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type or TFLite string type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::StringType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 1-bit signless integer or 32-bit signless integer or 64-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type or TFLite string type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult TopKV2Op::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<TopKV2Op>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 32-bit signless integer or 64-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 8-bit signless integer or 32-bit signless integer or 64-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSResults(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult TransposeConvOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<TransposeConvOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(3)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI32 type or 64-bit signless integer values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QI8 type or QUI8 type or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult TransposeOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<TransposeOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer or 32-bit float or 8-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type or TFLite quint8 type or 1-bit signless integer or 64-bit signless integer or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(32)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isF32())) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isa<mlir::TF::Quint8Type>())) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(64))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit signless integer or 32-bit float or 8-bit signless integer or 8-bit unsigned integer or QI8 type or QUI8 type or TFLite quint8 type or 1-bit signless integer or 64-bit signless integer or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult UnidirectionalSequenceLSTMOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<UnidirectionalSequenceLSTMOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(3)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(4)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(5)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(6)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(7)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(8)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(9)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(10)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(11)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(12)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(13)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(14)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(15)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(16)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(17)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(20)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(21)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(22)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(23)) {
      (void)v;
      if (!((((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (true); }(v.getType().cast<::mlir::ShapedType>().getElementType()))) || ((v.getType().isa<::mlir::NoneType>())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values or none type, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult UnidirectionalSequenceRNNOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<UnidirectionalSequenceRNNOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(2)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or QI8 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSOperands(3)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isF32()); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult UniqueOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<UniqueOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isSignlessInteger(16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isF32())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 8-bit signless integer or QI8 type or 8-bit unsigned integer or QUI8 type or 16-bit signless integer or QI16 type or 32-bit signless integer or 64-bit signless integer or 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isUnsignedInteger(8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isSignlessInteger(16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))) || ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))) || ((elementType.isF32())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 8-bit signless integer or QI8 type or 8-bit unsigned integer or QUI8 type or 16-bit signless integer or QI16 type or 32-bit signless integer or 64-bit signless integer or 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
    for (Value v : top.getODSResults(1)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32/64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult UnpackOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<UnpackOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))) || ((elementType.isSignlessInteger(32))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isSignlessInteger(16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 32-bit float or 1-bit signless integer or 8-bit signless integer or 8-bit unsigned integer or 32-bit signless integer or QI8 type or QUI8 type or 16-bit signless integer or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isF32())) || ((elementType.isSignlessInteger(1))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))) || ((elementType.isSignlessInteger(32))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 8))) || ((elementType.isSignlessInteger(16))) || (((elementType.isa<mlir::quant::QuantizedType>())) && ((elementType.cast<mlir::quant::QuantizedType>().getStorageTypeIntegralWidth() == 16))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 32-bit float or 1-bit signless integer or 8-bit signless integer or 8-bit unsigned integer or 32-bit signless integer or QI8 type or QUI8 type or 16-bit signless integer or QI16 type values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult VarHandleOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<VarHandleOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isa<mlir::TF::ResourceType>())) || ((elementType.isa<mlir::TF::ResourceRefType>())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of resource values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult WhereOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<WhereOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(1))) || ((elementType.isF32())) || (((elementType.isSignlessInteger(32))) || ((elementType.isSignlessInteger(64)))) || ((elementType.isSignlessInteger(8))) || ((elementType.isUnsignedInteger(8))) || ((elementType.isUnsignedInteger(32))); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 1-bit signless integer or 32-bit float or 32/64-bit signless integer or 8-bit signless integer or 8-bit unsigned integer or 32-bit unsigned integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return (elementType.isSignlessInteger(64)); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 64-bit signless integer values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult WhileOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<WhileOp>(op); (void)top;
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult YieldOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<YieldOp>(op); (void)top;
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
::mlir::LogicalResult ZerosLikeOp::VerifyTflRuntimeConstraints(::mlir::Operation *op, bool emit_error_on_verify_fail) {
  auto top = cast<ZerosLikeOp>(op); (void)top;
  {
    unsigned index = 0;
    for (Value v : top.getODSOperands(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(32))) || ((elementType.isF32())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("operand #") << index << " must be tensor of 64-bit signless integer or 32-bit signless integer or 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
  {
    unsigned index = 0;
    for (Value v : top.getODSResults(0)) {
      (void)v;
      if (!(((v.getType().isa<::mlir::TensorType>())) && ([](::mlir::Type elementType) { return ((elementType.isSignlessInteger(64))) || ((elementType.isSignlessInteger(32))) || ((elementType.isF32())); }(v.getType().cast<::mlir::ShapedType>().getElementType())))) {
        if (emit_error_on_verify_fail) {
        return op->emitOpError("result #") << index << " must be tensor of 64-bit signless integer or 32-bit signless integer or 32-bit float values, but got " << v.getType();
        } else {
          return failure();
        }
      }
      ++index;
    }
  }
    if (!emit_error_on_verify_fail) {
// Ignore transient errors by registering an no-op handler.
// Applying legalization patterns will emit unwanted, transient 
// errors when the replaced TFLite ops do not meet the sanity 
// checks. 
// In order to ignore the transient errors, the following lines 
// override a diagnostic handler with an no-op handler only
// while this pass runs.
uint64_t current_thread_id = llvm::get_threadid();
ScopedDiagnosticHandler scoped_diag_handler(
      top.getContext(), [&current_thread_id](Diagnostic&) -> LogicalResult {
        // Consume only errors that are coming from the same thread in order not
  // to ignore errors from other passes that are running. Things
         // running
     // in the pass manager can be multi-threaded.
        return success(current_thread_id == llvm::get_threadid());
   });
  return top.verify();
    } else {
  return top.verify();
}
}
